<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>Classwork</title>

    <script>

    /*
      Задание:
      1. При помощи методов изложеных ниже, переформатировать ITEA_COURSES в массив который содержит длину строк каждого из элементов.
      2. Используя метод Array.sort. Отфильтровать массив ITEA_COURSES по алфавиту.
          + Бонусный бал. Вывести на страничку списком
      3. Реализация функции поиска по массиву ITEA_COURSES.
          + Бонусный бал. Вывести на страничку инпут и кнопку по которой будет срабатывать поиск.
    */

    const ITEA_COURSES = ["Курс HTML & CSS", "JavaScript базовый курс", "JavaScript продвинутый курс", "JavaScript Professional", "Angular 2.4 (базовый)", "Angular 2.4 (продвинутый)", "React.js", "React Native", "Node.js", "Vue.js"];

    /*
      Задание 2:
      Написать фильтр массива по:
      Актеру, продолжительности

      Бонус:
        Сделать графическую оболочку для программы:
        - Селект со списком актеров
        - Селект или инпут с продолжительностью
        - Результат в виде списка фильмов
      <
        <select> <input type="number" name="duration" > <button> find </button>
      
          
    */

    let stars = ['Elijah Wood', 'Ian McKellen', 'Orlando Bloom', 'Ewan McGregor', 'Liam Neeson', 'Natalie Portman', 'Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
    let movies = [
      {
        name: "Lord of the Rigs",
        duration: 240,
        starring: [ 'Elijah Wood', 'Ian McKellen', 'Orlando Bloom']
      },
      {
        name: "Star Wars: Episode I - The Phantom Menace",
        duration: 136,
        starring: [ 'Ewan McGregor', 'Liam Neeson', 'Natalie Portman']
      },
      {
        name: "Fargo",
        duration: 100,
        starring: [ 'Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
      },
      {
        name: "V for Vendetta",
        duration: 150,
        starring: [ 'Hugo Weaving', 'Natalie Portman', 'Rupert Graves']
      }
    ];

    document.addEventListener('DOMContentLoaded', () => {
      // Task 1.
      let lengthArray = ITEA_COURSES.map(item => item.length);
      // console.log(lengthArray);

      let sortedArray = [...ITEA_COURSES].sort();
      const print = array => {
        let result1 = document.getElementById('result1');
        result1.innerHTML = null;
        array.map(item => {
          const div = document.createElement('div');
          div.innerText = item;
          result1.appendChild(div);
        });
      };
      // print(sortedArray);

      document.getElementById('search').addEventListener('input', e => {
        let inputText = e.target.value.toLowerCase();
        let result = ITEA_COURSES.filter(item => item.toLowerCase().indexOf(inputText) !== -1);
        print(result);
      });

      // Task 2.
      let duration = document.getElementById('duration');
      let select = document.getElementById('actor');
      let startOpt = new Option("-- Select actor --", null, true, true);
      select.appendChild(startOpt);

      let uniqueStars = stars.filter((v, i, a) => a.indexOf(v) === i);
      uniqueStars.forEach( item => {
        let opt = new Option(item, item, false, false);
        select.appendChild(opt);
      });

      document.getElementById('find').addEventListener('click', (e) => {
        let resultMovies = movies.filter(item => {
          if (item.duration < duration.value) {
            return false;
          }
          let resultActors = item.starring.filter(actor => actor.toLowerCase() === select.value.toLowerCase());
          return resultActors.length;
        });

        let result = document.getElementById('result2');
        result.innerHTML = null;
        if (resultMovies.length) {
          resultMovies.forEach(movie => {
            let div = document.createElement('div');
            div.innerHTML = `<p>Movie: ${movie.name}, Duration: ${movie.duration}<br>
            Actors: ${movie.starring.join(', ')} </p>`;
            result.appendChild(div);
          });
        } else {
          result.innerText = 'No films found for selected criteria.';
        }
      });

    });

    </script>
</head>
<body>
  <div id="result1"></div>
  <label>
      <span>Search by Courses</span>
      <input type="text" id="search" >
  </label>
  <br>
  <br>
  <div id="filmFilter">
      <label>
          <span>Actor</span>
          <select id="actor" name="actor"></select>
      </label>
      <label>
          <span>Duration more than:</span>
          <input type="number" id="duration" name="duration" >
      </label>
      <button id="find">Find</button>
  </div>
  <p>Results:</p>
  <div id="result2"></div>
</body>
</html>
